/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_PRIVACY_C_H__
#define __XMPP_PRIVACY_C_H__

#ifdef __cplusplus
extern "C" {
#endif

typedef void* xmpp_privacy_t;
typedef void (* xmpp_privacy_lists_retrieved_cb_type) 
                                                  (xmpp_privacy_t privacy,
                                                   void *data,
                                                   char **lists);
typedef void (* xmpp_privacy_rule_retrieved_cb_type)
                                                  (xmpp_privacy_t privacy,
                                                   void *data,
                                                   const char *list_name,
                                                   const char *type,
                                                   const char *value,
                                                   const char *action);

void          xmpp_privacy_list_request_lists     (xmpp_privacy_t privacy);
void          xmpp_privacy_list_request_rules     (xmpp_privacy_t privacy,
                                                   const char *name);
void          xmpp_privacy_list_get_default       (xmpp_privacy_t privacy);
void          xmpp_privacy_list_set_default       (xmpp_privacy_t privacy,
                                                   const char *name);
void          xmpp_privacy_list_get_active        (xmpp_privacy_t privacy);
void          xmpp_privacy_list_set_active        (xmpp_privacy_t privacy,
                                                   const char *name);
void          xmpp_privacy_list_add_rule          (xmpp_privacy_t privacy,
                                                   const char *list_name,
                                                   const char *type,
                                                   const char *value,
                                                   const char *action);
void          xmpp_privacy_list_remove_rule       (xmpp_privacy_t privacy,
                                                   const char *list_name,
                                                   const char *type,
                                                   const char *value,
                                                   const char *action);
void          xmpp_privacy_set_rule_retrieved_cb  (xmpp_privacy_t privacy,
                                                   xmpp_privacy_rule_retrieved_cb_type cb,
                                                   void *data);
void          xmpp_privacy_set_lists_retrieved_cb (xmpp_privacy_t privacy,
                                                   xmpp_privacy_lists_retrieved_cb_type cb,
                                                   void *data);
   
#ifdef __cplusplus
}
#endif

#endif
